function GetOciTopLevelCommand_network() {
    return 'network'
}

function GetOciSubcommands_network() {
    $ociSubcommands = @{
        'network' = 'cpe cross-connect cross-connect-group cross-connect-location cross-connect-port-speed-shape cross-connect-status dhcp-options drg drg-attachment fast-connect-provider-service internet-gateway ip-sec-connection local-peering-gateway nat-gateway private-ip public-ip remote-peering-connection route-table security-list service service-gateway subnet vcn virtual-circuit virtual-circuit-public-prefix vnic'
        'network cpe' = 'create delete get list update'
        'network cross-connect' = 'create delete get list update'
        'network cross-connect-group' = 'create delete get list update'
        'network cross-connect-location' = 'list'
        'network cross-connect-port-speed-shape' = 'list'
        'network cross-connect-status' = 'get'
        'network dhcp-options' = 'create delete get list update'
        'network drg' = 'create delete get list update'
        'network drg-attachment' = 'create delete get list update'
        'network fast-connect-provider-service' = 'get list virtual-circuit-bandwidth-shape'
        'network fast-connect-provider-service virtual-circuit-bandwidth-shape' = 'list'
        'network internet-gateway' = 'create delete get list update'
        'network ip-sec-connection' = 'create delete get get-config get-status list update'
        'network local-peering-gateway' = 'connect create delete get list update'
        'network nat-gateway' = 'create delete get list update'
        'network private-ip' = 'delete get list update'
        'network public-ip' = 'create delete get list update'
        'network remote-peering-connection' = 'connect create delete get list update'
        'network route-table' = 'create delete get list update'
        'network security-list' = 'create delete get list update'
        'network service' = 'get list'
        'network service-gateway' = 'attach create delete detach get list update'
        'network subnet' = 'create delete get list update'
        'network vcn' = 'create delete get list update'
        'network virtual-circuit' = 'create delete get list update'
        'network virtual-circuit-public-prefix' = 'bulk-add bulk-delete list'
        'network vnic' = 'assign-private-ip get unassign-private-ip update'
    }
    return $ociSubcommands
}

function GetOciCommandsToLongParams_network() {
    $ociCommandsToLongParams = @{
        'network cpe create' = 'compartment-id defined-tags display-name freeform-tags from-json help ip-address'
        'network cpe delete' = 'cpe-id force from-json help if-match'
        'network cpe get' = 'cpe-id from-json help'
        'network cpe list' = 'all compartment-id from-json help limit page page-size'
        'network cpe update' = 'cpe-id defined-tags display-name force freeform-tags from-json help if-match'
        'network cross-connect create' = 'compartment-id cross-connect-group-id display-name far-cross-connect-or-cross-connect-group-id from-json help location-name max-wait-seconds near-cross-connect-or-cross-connect-group-id port-speed-shape-name wait-for-state wait-interval-seconds'
        'network cross-connect delete' = 'cross-connect-id force from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'network cross-connect get' = 'cross-connect-id from-json help'
        'network cross-connect list' = 'all compartment-id cross-connect-group-id display-name from-json help lifecycle-state limit page page-size sort-by sort-order'
        'network cross-connect update' = 'cross-connect-id display-name from-json help if-match is-active max-wait-seconds wait-for-state wait-interval-seconds'
        'network cross-connect-group create' = 'compartment-id display-name from-json help max-wait-seconds wait-for-state wait-interval-seconds'
        'network cross-connect-group delete' = 'cross-connect-group-id force from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'network cross-connect-group get' = 'cross-connect-group-id from-json help'
        'network cross-connect-group list' = 'all compartment-id display-name from-json help lifecycle-state limit page page-size sort-by sort-order'
        'network cross-connect-group update' = 'cross-connect-group-id display-name from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'network cross-connect-location list' = 'all compartment-id from-json help limit page page-size'
        'network cross-connect-port-speed-shape list' = 'all compartment-id from-json help limit page page-size'
        'network cross-connect-status get' = 'cross-connect-id from-json help'
        'network dhcp-options create' = 'compartment-id defined-tags display-name freeform-tags from-json help max-wait-seconds options vcn-id wait-for-state wait-interval-seconds'
        'network dhcp-options delete' = 'dhcp-id force from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'network dhcp-options get' = 'dhcp-id from-json help'
        'network dhcp-options list' = 'all compartment-id display-name from-json help lifecycle-state limit page page-size sort-by sort-order vcn-id'
        'network dhcp-options update' = 'defined-tags dhcp-id display-name force freeform-tags from-json help if-match max-wait-seconds options wait-for-state wait-interval-seconds'
        'network drg create' = 'compartment-id defined-tags display-name freeform-tags from-json help max-wait-seconds wait-for-state wait-interval-seconds'
        'network drg delete' = 'drg-id force from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'network drg get' = 'drg-id from-json help'
        'network drg list' = 'all compartment-id from-json help limit page page-size'
        'network drg update' = 'defined-tags display-name drg-id force freeform-tags from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'network drg-attachment create' = 'display-name drg-id from-json help max-wait-seconds route-table-id vcn-id wait-for-state wait-interval-seconds'
        'network drg-attachment delete' = 'drg-attachment-id force from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'network drg-attachment get' = 'drg-attachment-id from-json help'
        'network drg-attachment list' = 'all compartment-id drg-id from-json help limit page page-size vcn-id'
        'network drg-attachment update' = 'display-name drg-attachment-id from-json help if-match max-wait-seconds route-table-id wait-for-state wait-interval-seconds'
        'network fast-connect-provider-service get' = 'from-json help provider-service-id'
        'network fast-connect-provider-service list' = 'all compartment-id from-json help limit page page-size'
        'network fast-connect-provider-service virtual-circuit-bandwidth-shape list' = 'all from-json help limit page page-size provider-service-id'
        'network internet-gateway create' = 'compartment-id defined-tags display-name freeform-tags from-json help is-enabled max-wait-seconds vcn-id wait-for-state wait-interval-seconds'
        'network internet-gateway delete' = 'force from-json help if-match ig-id max-wait-seconds wait-for-state wait-interval-seconds'
        'network internet-gateway get' = 'from-json help ig-id'
        'network internet-gateway list' = 'all compartment-id display-name from-json help lifecycle-state limit page page-size sort-by sort-order vcn-id'
        'network internet-gateway update' = 'defined-tags display-name force freeform-tags from-json help if-match ig-id is-enabled max-wait-seconds wait-for-state wait-interval-seconds'
        'network ip-sec-connection create' = 'compartment-id cpe-id defined-tags display-name drg-id freeform-tags from-json help max-wait-seconds static-routes wait-for-state wait-interval-seconds'
        'network ip-sec-connection delete' = 'force from-json help if-match ipsc-id max-wait-seconds wait-for-state wait-interval-seconds'
        'network ip-sec-connection get' = 'from-json help ipsc-id'
        'network ip-sec-connection get-config' = 'from-json help ipsc-id'
        'network ip-sec-connection get-status' = 'from-json help ipsc-id'
        'network ip-sec-connection list' = 'all compartment-id cpe-id drg-id from-json help limit page page-size'
        'network ip-sec-connection update' = 'defined-tags display-name force freeform-tags from-json help if-match ipsc-id max-wait-seconds wait-for-state wait-interval-seconds'
        'network local-peering-gateway connect' = 'from-json help local-peering-gateway-id peer-id'
        'network local-peering-gateway create' = 'compartment-id defined-tags display-name freeform-tags from-json help max-wait-seconds route-table-id vcn-id wait-for-state wait-interval-seconds'
        'network local-peering-gateway delete' = 'force from-json help if-match local-peering-gateway-id max-wait-seconds wait-for-state wait-interval-seconds'
        'network local-peering-gateway get' = 'from-json help local-peering-gateway-id'
        'network local-peering-gateway list' = 'all compartment-id from-json help limit page page-size vcn-id'
        'network local-peering-gateway update' = 'defined-tags display-name force freeform-tags from-json help if-match local-peering-gateway-id max-wait-seconds route-table-id wait-for-state wait-interval-seconds'
        'network nat-gateway create' = 'block-traffic compartment-id defined-tags display-name freeform-tags from-json help max-wait-seconds vcn-id wait-for-state wait-interval-seconds'
        'network nat-gateway delete' = 'force from-json help if-match max-wait-seconds nat-gateway-id wait-for-state wait-interval-seconds'
        'network nat-gateway get' = 'from-json help nat-gateway-id'
        'network nat-gateway list' = 'all compartment-id display-name from-json help lifecycle-state limit page page-size sort-by sort-order vcn-id'
        'network nat-gateway update' = 'block-traffic defined-tags display-name force freeform-tags from-json help if-match max-wait-seconds nat-gateway-id wait-for-state wait-interval-seconds'
        'network private-ip delete' = 'force from-json help if-match private-ip-id'
        'network private-ip get' = 'from-json help private-ip-id'
        'network private-ip list' = 'all from-json help ip-address limit page page-size subnet-id vnic-id'
        'network private-ip update' = 'defined-tags display-name force freeform-tags from-json help hostname-label if-match private-ip-id'
        'network public-ip create' = 'compartment-id defined-tags display-name freeform-tags from-json help lifetime max-wait-seconds private-ip-id wait-for-state wait-interval-seconds'
        'network public-ip delete' = 'force from-json help if-match max-wait-seconds public-ip-id wait-for-state wait-interval-seconds'
        'network public-ip get' = 'from-json help private-ip-id public-ip-address public-ip-id'
        'network public-ip list' = 'all availability-domain compartment-id from-json help lifetime limit page page-size scope'
        'network public-ip update' = 'defined-tags display-name force freeform-tags from-json help if-match max-wait-seconds private-ip-id public-ip-id wait-for-state wait-interval-seconds'
        'network remote-peering-connection connect' = 'from-json help peer-id peer-region-name remote-peering-connection-id'
        'network remote-peering-connection create' = 'compartment-id display-name drg-id from-json help max-wait-seconds wait-for-state wait-interval-seconds'
        'network remote-peering-connection delete' = 'force from-json help if-match max-wait-seconds remote-peering-connection-id wait-for-state wait-interval-seconds'
        'network remote-peering-connection get' = 'from-json help remote-peering-connection-id'
        'network remote-peering-connection list' = 'all compartment-id drg-id from-json help limit page page-size'
        'network remote-peering-connection update' = 'display-name from-json help if-match max-wait-seconds remote-peering-connection-id wait-for-state wait-interval-seconds'
        'network route-table create' = 'compartment-id defined-tags display-name freeform-tags from-json help max-wait-seconds route-rules vcn-id wait-for-state wait-interval-seconds'
        'network route-table delete' = 'force from-json help if-match max-wait-seconds rt-id wait-for-state wait-interval-seconds'
        'network route-table get' = 'from-json help rt-id'
        'network route-table list' = 'all compartment-id display-name from-json help lifecycle-state limit page page-size sort-by sort-order vcn-id'
        'network route-table update' = 'defined-tags display-name force freeform-tags from-json help if-match max-wait-seconds route-rules rt-id wait-for-state wait-interval-seconds'
        'network security-list create' = 'compartment-id defined-tags display-name egress-security-rules freeform-tags from-json help ingress-security-rules max-wait-seconds vcn-id wait-for-state wait-interval-seconds'
        'network security-list delete' = 'force from-json help if-match max-wait-seconds security-list-id wait-for-state wait-interval-seconds'
        'network security-list get' = 'from-json help security-list-id'
        'network security-list list' = 'all compartment-id display-name from-json help lifecycle-state limit page page-size sort-by sort-order vcn-id'
        'network security-list update' = 'defined-tags display-name egress-security-rules force freeform-tags from-json help if-match ingress-security-rules max-wait-seconds security-list-id wait-for-state wait-interval-seconds'
        'network service get' = 'from-json help service-id'
        'network service list' = 'all from-json help limit page page-size'
        'network service-gateway attach' = 'from-json help if-match max-wait-seconds service-gateway-id service-id wait-for-state wait-interval-seconds'
        'network service-gateway create' = 'compartment-id defined-tags display-name freeform-tags from-json help max-wait-seconds services vcn-id wait-for-state wait-interval-seconds'
        'network service-gateway delete' = 'force from-json help if-match max-wait-seconds service-gateway-id wait-for-state wait-interval-seconds'
        'network service-gateway detach' = 'from-json help if-match max-wait-seconds service-gateway-id service-id wait-for-state wait-interval-seconds'
        'network service-gateway get' = 'from-json help service-gateway-id'
        'network service-gateway list' = 'all compartment-id from-json help lifecycle-state limit page page-size sort-by sort-order vcn-id'
        'network service-gateway update' = 'block-traffic defined-tags display-name force freeform-tags from-json help if-match max-wait-seconds service-gateway-id services wait-for-state wait-interval-seconds'
        'network subnet create' = 'availability-domain cidr-block compartment-id defined-tags dhcp-options-id display-name dns-label freeform-tags from-json help max-wait-seconds prohibit-public-ip-on-vnic route-table-id security-list-ids vcn-id wait-for-state wait-interval-seconds'
        'network subnet delete' = 'force from-json help if-match max-wait-seconds subnet-id wait-for-state wait-interval-seconds'
        'network subnet get' = 'from-json help subnet-id'
        'network subnet list' = 'all compartment-id display-name from-json help lifecycle-state limit page page-size sort-by sort-order vcn-id'
        'network subnet update' = 'defined-tags dhcp-options-id display-name force freeform-tags from-json help if-match max-wait-seconds route-table-id security-list-ids subnet-id wait-for-state wait-interval-seconds'
        'network vcn create' = 'cidr-block compartment-id defined-tags display-name dns-label freeform-tags from-json help max-wait-seconds wait-for-state wait-interval-seconds'
        'network vcn delete' = 'force from-json help if-match max-wait-seconds vcn-id wait-for-state wait-interval-seconds'
        'network vcn get' = 'from-json help vcn-id'
        'network vcn list' = 'all compartment-id display-name from-json help lifecycle-state limit page page-size sort-by sort-order'
        'network vcn update' = 'defined-tags display-name force freeform-tags from-json help if-match max-wait-seconds vcn-id wait-for-state wait-interval-seconds'
        'network virtual-circuit create' = 'bandwidth-shape-name compartment-id cross-connect-mappings customer-bgp-asn display-name from-json gateway-id help max-wait-seconds provider-name provider-service-id provider-service-name public-prefixes region type wait-for-state wait-interval-seconds'
        'network virtual-circuit delete' = 'force from-json help if-match max-wait-seconds virtual-circuit-id wait-for-state wait-interval-seconds'
        'network virtual-circuit get' = 'from-json help virtual-circuit-id'
        'network virtual-circuit list' = 'all compartment-id display-name from-json help lifecycle-state limit page page-size sort-by sort-order'
        'network virtual-circuit update' = 'bandwidth-shape-name cross-connect-mappings customer-bgp-asn display-name force from-json gateway-id help if-match max-wait-seconds provider-state reference-comment virtual-circuit-id wait-for-state wait-interval-seconds'
        'network virtual-circuit-public-prefix bulk-add' = 'from-json help public-prefixes virtual-circuit-id'
        'network virtual-circuit-public-prefix bulk-delete' = 'from-json help public-prefixes virtual-circuit-id'
        'network virtual-circuit-public-prefix list' = 'all from-json help verification-state virtual-circuit-id'
        'network vnic assign-private-ip' = 'defined-tags display-name freeform-tags from-json help hostname-label ip-address unassign-if-already-assigned vnic-id'
        'network vnic get' = 'from-json help vnic-id'
        'network vnic unassign-private-ip' = 'from-json help ip-address vnic-id'
        'network vnic update' = 'defined-tags display-name force freeform-tags from-json help hostname-label if-match max-wait-seconds skip-source-dest-check vnic-id wait-for-state wait-interval-seconds'
    }
    return $ociCommandsToLongParams
}

function GetOciCommandsToShortParams_network() {
    $ociCommandsToShortParams = @{
        'network cpe create' = '? c h'
        'network cpe delete' = '? h'
        'network cpe get' = '? h'
        'network cpe list' = '? c h'
        'network cpe update' = '? h'
        'network cross-connect create' = '? c h'
        'network cross-connect delete' = '? h'
        'network cross-connect get' = '? h'
        'network cross-connect list' = '? c h'
        'network cross-connect update' = '? h'
        'network cross-connect-group create' = '? c h'
        'network cross-connect-group delete' = '? h'
        'network cross-connect-group get' = '? h'
        'network cross-connect-group list' = '? c h'
        'network cross-connect-group update' = '? h'
        'network cross-connect-location list' = '? c h'
        'network cross-connect-port-speed-shape list' = '? c h'
        'network cross-connect-status get' = '? h'
        'network dhcp-options create' = '? c h'
        'network dhcp-options delete' = '? h'
        'network dhcp-options get' = '? h'
        'network dhcp-options list' = '? c h'
        'network dhcp-options update' = '? h'
        'network drg create' = '? c h'
        'network drg delete' = '? h'
        'network drg get' = '? h'
        'network drg list' = '? c h'
        'network drg update' = '? h'
        'network drg-attachment create' = '? h'
        'network drg-attachment delete' = '? h'
        'network drg-attachment get' = '? h'
        'network drg-attachment list' = '? c h'
        'network drg-attachment update' = '? h'
        'network fast-connect-provider-service get' = '? h'
        'network fast-connect-provider-service list' = '? c h'
        'network fast-connect-provider-service virtual-circuit-bandwidth-shape list' = '? h'
        'network internet-gateway create' = '? c h'
        'network internet-gateway delete' = '? h'
        'network internet-gateway get' = '? h'
        'network internet-gateway list' = '? c h'
        'network internet-gateway update' = '? h'
        'network ip-sec-connection create' = '? c h'
        'network ip-sec-connection delete' = '? h'
        'network ip-sec-connection get' = '? h'
        'network ip-sec-connection get-config' = '? h'
        'network ip-sec-connection get-status' = '? h'
        'network ip-sec-connection list' = '? c h'
        'network ip-sec-connection update' = '? h'
        'network local-peering-gateway connect' = '? h'
        'network local-peering-gateway create' = '? c h'
        'network local-peering-gateway delete' = '? h'
        'network local-peering-gateway get' = '? h'
        'network local-peering-gateway list' = '? c h'
        'network local-peering-gateway update' = '? h'
        'network nat-gateway create' = '? c h'
        'network nat-gateway delete' = '? h'
        'network nat-gateway get' = '? h'
        'network nat-gateway list' = '? c h'
        'network nat-gateway update' = '? h'
        'network private-ip delete' = '? h'
        'network private-ip get' = '? h'
        'network private-ip list' = '? h'
        'network private-ip update' = '? h'
        'network public-ip create' = '? c h'
        'network public-ip delete' = '? h'
        'network public-ip get' = '? h'
        'network public-ip list' = '? c h'
        'network public-ip update' = '? h'
        'network remote-peering-connection connect' = '? h'
        'network remote-peering-connection create' = '? c h'
        'network remote-peering-connection delete' = '? h'
        'network remote-peering-connection get' = '? h'
        'network remote-peering-connection list' = '? c h'
        'network remote-peering-connection update' = '? h'
        'network route-table create' = '? c h'
        'network route-table delete' = '? h'
        'network route-table get' = '? h'
        'network route-table list' = '? c h'
        'network route-table update' = '? h'
        'network security-list create' = '? c h'
        'network security-list delete' = '? h'
        'network security-list get' = '? h'
        'network security-list list' = '? c h'
        'network security-list update' = '? h'
        'network service get' = '? h'
        'network service list' = '? h'
        'network service-gateway attach' = '? h'
        'network service-gateway create' = '? c h'
        'network service-gateway delete' = '? h'
        'network service-gateway detach' = '? h'
        'network service-gateway get' = '? h'
        'network service-gateway list' = '? c h'
        'network service-gateway update' = '? h'
        'network subnet create' = '? c h'
        'network subnet delete' = '? h'
        'network subnet get' = '? h'
        'network subnet list' = '? c h'
        'network subnet update' = '? h'
        'network vcn create' = '? c h'
        'network vcn delete' = '? h'
        'network vcn get' = '? h'
        'network vcn list' = '? c h'
        'network vcn update' = '? h'
        'network virtual-circuit create' = '? c h'
        'network virtual-circuit delete' = '? h'
        'network virtual-circuit get' = '? h'
        'network virtual-circuit list' = '? c h'
        'network virtual-circuit update' = '? h'
        'network virtual-circuit-public-prefix bulk-add' = '? h'
        'network virtual-circuit-public-prefix bulk-delete' = '? h'
        'network virtual-circuit-public-prefix list' = '? h'
        'network vnic assign-private-ip' = '? h'
        'network vnic get' = '? h'
        'network vnic unassign-private-ip' = '? h'
        'network vnic update' = '? h'
    }
    return $ociCommandsToShortParams
}